//---------------------------------------------------------------------------
//
// Name:        MainDlg.cpp
// Author:      ...
// Created:     11/23/2004
// Copyright:
//
//---------------------------------------------------------------------------

#ifdef __GNUG__
  #pragma implementation "MainDlg.cpp"
#endif

/* for compilers that support precompilation
   includes "wx/wx.h" */

#include "wx/wxprec.h"

#ifdef __BORLANDC__
  #pragma hdrstop
#endif

#include "MainDlg.h"

////Header Include Start
#include "MainDlg_XPM.xpm"
////Header Include End

#ifdef __WXMSW__
const char * ConfigFilenameString = "avrdude-gui";
#else
const char * ConfigFilenameString = "/.avrdude-guirc";
#endif


//----------------------------------------------------------------------------
// MainDlg
//----------------------------------------------------------------------------

  ////Event Table Start
BEGIN_EVENT_TABLE(MainDlg,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(MainDlg::MainDlgClose)
	EVT_INIT_DIALOG(MainDlg::MainDlgInit)
	EVT_BUTTON(ID_BTNABOUT,MainDlg::WxbtnAboutClick)
	EVT_CHECKBOX(ID_CHKLPTPOWERON,MainDlg::LptPowerOn)
	EVT_BUTTON(ID_BTNEXECUTE,MainDlg::Execute)
	
	EVT_TEXT(ID_EDTCYCLECOUNTER,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKCCERASE,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKCCSET,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKEXITVCC,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKEXITNOVCC,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKEXITRESET,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKEXITNORESET,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKOPTDISABLEOUTPUT,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKOPTDISABLEVERIFY,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKOPTVERBOSEOUTPUT,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKOPTTERMINAL,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKOPTVERIFYSIGNATURE,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKOPTDONTWRITE,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKOPTAUTOERASE,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKOPTCHIPERASE,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKWRITESIGNATURE,MainDlg::ChangeSettings)
	
	EVT_TEXT(ID_EDTSIGNATURE,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKREADSIGNATURE,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKWRITECALIBRATION,MainDlg::ChangeSettings)
	
	EVT_TEXT(ID_EDTCALIBRATION,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKREADCALIBRATION,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKWRITEEFUSE,MainDlg::ChangeSettings)
	
	EVT_TEXT(ID_EDTEFUSE,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKREADEFUSE,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKWRITELOCKFUSE,MainDlg::ChangeSettings)
	
	EVT_TEXT(ID_EDTLOCKFUSE,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKREADLOCKFUSE,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKWRITEHFUSE,MainDlg::ChangeSettings)
	
	EVT_TEXT(ID_EDTHFUSE,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKREADHFUSE,MainDlg::ChangeSettings)
	
	EVT_TEXT(ID_EDTLFUSE,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKREADLFUSE,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKWRITELFUSE,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKWRITEEEPROM,MainDlg::ChangeSettings)
	
	EVT_TEXT(ID_WXCOMBOBOX1,MainDlg::ChangeSettings)
	EVT_BUTTON(ID_WXBUTTON2,MainDlg::SelectEeprom)
	EVT_CHECKBOX(ID_WXCHECKBOX3,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_WXCHECKBOX2,MainDlg::ChangeSettings)
	
	EVT_TEXT(ID_WXEDIT2,MainDlg::ChangeSettings)
	EVT_BUTTON(ID_BTNSTATUSGIVEIO,MainDlg::StatusGiveio)
	EVT_BUTTON(ID_BTNREMOVEGIVEIO,MainDlg::RemoveGiveio)
	EVT_BUTTON(ID_BTNINSTALLGIVEIO,MainDlg::InstallGiveio)
	
	EVT_TEXT(ID_CMBFLASHFORMAT,MainDlg::ChangeSettings)
	EVT_BUTTON(ID_BTNOPENFLASHFILE,MainDlg::SelectFlash)
	EVT_CHECKBOX(ID_CHKVERIFYFLASH,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKREADFLASH,MainDlg::ChangeSettings)
	EVT_CHECKBOX(ID_CHKWRITEFLASH,MainDlg::ChangeSettings)
	
	EVT_TEXT(ID_EDTFLASHFILE,MainDlg::ChangeSettings)
	
	EVT_TEXT(ID_CMBPORT,MainDlg::ChangeSettings)
	
	EVT_TEXT(ID_CMBPROGRAMMER,MainDlg::ChangeSettings)
	
	EVT_TEXT(ID_CMBDEVICE,MainDlg::ChangeSettings)
	EVT_BUTTON(ID_WXBUTTON1,MainDlg::SelectConfFile)
	
	EVT_TEXT(ID_WXEDIT1,MainDlg::ChangeSettings)
	EVT_BUTTON(ID_BTNOPENAVRDUDEFILE,MainDlg::SelectAvrdude)
	
	EVT_TEXT(ID_EDTAVRDUDE,MainDlg::ChangeSettings)
END_EVENT_TABLE()
    ////Event Table End



MainDlg::MainDlg( wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style )
    : wxDialog( parent, id, title, position, size, style)
{
  CreateGUIControls();
  BuildCmdLine();
}

MainDlg::~MainDlg()
{
} 

void MainDlg::CreateGUIControls(void)
{
    m_ControlsCreated = 0;

#ifdef __WXMSW__
//ToDo: doesn't work :(   this->SetExtraStyle(wxDIALOG_EX_CONTEXTHELP);
#endif

  ////GUI Items Creation Start

	this->SetSize(34,1,601,662);
	this->SetTitle(wxT("avrdude gui v0.2.0"));
	this->Center();
	wxIcon MainDlg_ICON (MainDlg_XPM);
	this->SetIcon(MainDlg_XPM);
	this->SetToolTip(wxT("0"));
	

	lbxOutput = new wxTextCtrl(this, ID_LBXOUTPUT, wxT(""), wxPoint(4,442), wxSize(584,189), wxTE_MULTILINE, wxDefaultValidator, wxT("lbxOutput"));
	lbxOutput->SetMaxLength(0);
	lbxOutput->SetFocus();
	lbxOutput->SetInsertionPointEnd();
	lbxOutput->SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_BTNFACE));
	lbxOutput->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("Courier New")));

	OpenFileDialogEeprom =  new wxFileDialog(this, wxT("Choose EEPROM file"), wxT(""), wxT(""), wxT("Eeprom file (*.hex,*.bin) | *.hex;*.bin"), wxOPEN);

	OpenFileDialogAvrdude =  new wxFileDialog(this, wxT("Choose location of avrdude"), wxT(""), wxT("avrdude"), wxT("avrdude executable (avrdude.*) | avrdude.*"), wxOPEN);

	OpenFileDialogConfFile =  new wxFileDialog(this, wxT("Choose location of configuration file"), wxT(""), wxT(""), wxT("avrdude conf file (*.*) | *.*"), wxOPEN);

	OpenFileDialogFlash =  new wxFileDialog(this, wxT("Choose flash file"), wxT(""), wxT(""), wxT("Flash file (*.hex,*.bin) | *.hex;*.bin"), wxOPEN);

	btnAbout = new wxButton(this, ID_BTNABOUT, wxT("?"), wxPoint(574,2), wxSize(17,18), 0, wxDefaultValidator, wxT("btnAbout"));

	chkLptPowerOn = new wxCheckBox(this, ID_CHKLPTPOWERON, wxT("LPT Power On"), wxPoint(365,65), wxSize(100,23), 0, wxDefaultValidator, wxT("chkLptPowerOn"));

	edtCmdline = new wxTextCtrl(this, ID_EDTCMDLINE, wxT(""), wxPoint(4,416), wxSize(511,22), wxTE_RICH, wxDefaultValidator, wxT("edtCmdline"));
	edtCmdline->SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_BTNFACE));
	edtCmdline->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("Courier New")));

	btnExecute = new wxButton(this, ID_BTNEXECUTE, wxT("Execute"), wxPoint(523,416), wxSize(65,22), 0, wxDefaultValidator, wxT("btnExecute"));
	btnExecute->SetForegroundColour(wxColour(0,0,0));
	btnExecute->SetBackgroundColour(*wxRED);
	btnExecute->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxBOLD, FALSE));

	WxStaticText14 = new wxStaticText(this, ID_WXSTATICTEXT14, wxT("Command line:"), wxPoint(13,399), wxSize(73,17), 0, wxT("WxStaticText14"));

	edtCycleCounter = new wxTextCtrl(this, ID_EDTCYCLECOUNTER, wxT("0"), wxPoint(517,282), wxSize(31,21), 0, wxDefaultValidator, wxT("edtCycleCounter"));

	chkCcErase = new wxCheckBox(this, ID_CHKCCERASE, wxT("-y erase"), wxPoint(487,249), wxSize(67,15), 0, wxDefaultValidator, wxT("chkCcErase"));

	chkCcSet = new wxCheckBox(this, ID_CHKCCSET, wxT("-Y Set to:"), wxPoint(487,265), wxSize(68,15), 0, wxDefaultValidator, wxT("chkCcSet"));

	chkExitVcc = new wxCheckBox(this, ID_CHKEXITVCC, wxT("Vcc"), wxPoint(504,328), wxSize(75,17), 0, wxDefaultValidator, wxT("chkExitVcc"));

	chkExitNovcc = new wxCheckBox(this, ID_CHKEXITNOVCC, wxT("No Vcc"), wxPoint(504,344), wxSize(74,17), 0, wxDefaultValidator, wxT("chkExitNovcc"));

	chkExitReset = new wxCheckBox(this, ID_CHKEXITRESET, wxT("Reset"), wxPoint(406,328), wxSize(75,17), 0, wxDefaultValidator, wxT("chkExitReset"));

	chkExitNoreset = new wxCheckBox(this, ID_CHKEXITNORESET, wxT("No reset"), wxPoint(406,344), wxSize(75,17), 0, wxDefaultValidator, wxT("chkExitNoreset"));

	chkOptDisableOutput = new wxCheckBox(this, ID_CHKOPTDISABLEOUTPUT, wxT("-q Disable process bar output"), wxPoint(211,328), wxSize(176,17), 0, wxDefaultValidator, wxT("chkOptDisableOutput"));

	chkOptDisableVerify = new wxCheckBox(this, ID_CHKOPTDISABLEVERIFY, wxT("-V Disable verify check"), wxPoint(211,360), wxSize(177,17), 0, wxDefaultValidator, wxT("chkOptDisableVerify"));

	chkOptVerboseOutput = new wxCheckBox(this, ID_CHKOPTVERBOSEOUTPUT, wxT("-v Enable verbose output"), wxPoint(211,344), wxSize(175,17), 0, wxDefaultValidator, wxT("chkOptVerboseOutput"));

	chkOptTerminal = new wxCheckBox(this, ID_CHKOPTTERMINAL, wxT("-t Terminal mode"), wxPoint(211,376), wxSize(175,17), 0, wxDefaultValidator, wxT("chkOptTerminal"));
	chkOptTerminal->Show(false);

	chkOptVerifySignature = new wxCheckBox(this, ID_CHKOPTVERIFYSIGNATURE, wxT("-F Override signature check"), wxPoint(12,360), wxSize(185,17), 0, wxDefaultValidator, wxT("chkOptVerifySignature"));

	chkOptDontWrite = new wxCheckBox(this, ID_CHKOPTDONTWRITE, wxT("-n Don't write to the device"), wxPoint(12,376), wxSize(185,17), 0, wxDefaultValidator, wxT("chkOptDontWrite"));

	chkOptAutoErase = new wxCheckBox(this, ID_CHKOPTAUTOERASE, wxT("-D Disable auto erase for flash"), wxPoint(12,328), wxSize(185,17), 0, wxDefaultValidator, wxT("chkOptAutoErase"));

	chkOptChipErase = new wxCheckBox(this, ID_CHKOPTCHIPERASE, wxT("-e Perform a chip erase"), wxPoint(12,344), wxSize(185,17), 0, wxDefaultValidator, wxT("chkOptChipErase"));

	WxStaticBox12 = new wxStaticBox(this, ID_WXSTATICBOX12, wxT("Erase cycle counter"), wxPoint(481,231), wxSize(107,79));

	WxStaticBox11 = new wxStaticBox(this, ID_WXSTATICBOX11, wxT("-E Exitmode"), wxPoint(400,312), wxSize(188,56));

	WxStaticBox10 = new wxStaticBox(this, ID_WXSTATICBOX10, wxT("Options"), wxPoint(4,312), wxSize(387,86));

	chkWriteSignature = new wxCheckBox(this, ID_CHKWRITESIGNATURE, wxT("Write"), wxPoint(408,248), wxSize(55,17), 0, wxDefaultValidator, wxT("chkWriteSignature"));

	edtSignature = new wxTextCtrl(this, ID_EDTSIGNATURE, wxT("000000"), wxPoint(425,282), wxSize(44,21), 0, wxDefaultValidator, wxT("edtSignature"));

	WxStaticText13 = new wxStaticText(this, ID_WXSTATICTEXT13, wxT("0x"), wxPoint(410,285), wxSize(15,17), 0, wxT("WxStaticText13"));

	chkReadSignature = new wxCheckBox(this, ID_CHKREADSIGNATURE, wxT("Read"), wxPoint(408,264), wxSize(55,17), 0, wxDefaultValidator, wxT("chkReadSignature"));

	chkWriteCalibration = new wxCheckBox(this, ID_CHKWRITECALIBRATION, wxT("Write"), wxPoint(310,248), wxSize(55,17), 0, wxDefaultValidator, wxT("chkWriteCalibration"));

	edtCalibration = new wxTextCtrl(this, ID_EDTCALIBRATION, wxT("00000000"), wxPoint(329,282), wxSize(56,21), 0, wxDefaultValidator, wxT("edtCalibration"));

	WxStaticText12 = new wxStaticText(this, ID_WXSTATICTEXT12, wxT("0x"), wxPoint(314,285), wxSize(15,17), 0, wxT("WxStaticText12"));

	chkReadCalibration = new wxCheckBox(this, ID_CHKREADCALIBRATION, wxT("Read"), wxPoint(310,264), wxSize(55,17), 0, wxDefaultValidator, wxT("chkReadCalibration"));

	chkWriteEfuse = new wxCheckBox(this, ID_CHKWRITEEFUSE, wxT("Write"), wxPoint(236,248), wxSize(55,17), 0, wxDefaultValidator, wxT("chkWriteEfuse"));

	edtEfuse = new wxTextCtrl(this, ID_EDTEFUSE, wxT("00"), wxPoint(254,282), wxSize(21,21), 0, wxDefaultValidator, wxT("edtEfuse"));

	WxStaticText11 = new wxStaticText(this, ID_WXSTATICTEXT11, wxT("0x"), wxPoint(239,285), wxSize(15,17), 0, wxT("WxStaticText11"));

	chkReadEfuse = new wxCheckBox(this, ID_CHKREADEFUSE, wxT("Read"), wxPoint(236,264), wxSize(55,17), 0, wxDefaultValidator, wxT("chkReadEfuse"));

	chkWriteLockfuse = new wxCheckBox(this, ID_CHKWRITELOCKFUSE, wxT("Write"), wxPoint(161,248), wxSize(55,17), 0, wxDefaultValidator, wxT("chkWriteLockfuse"));

	edtLockfuse = new wxTextCtrl(this, ID_EDTLOCKFUSE, wxT("00"), wxPoint(179,282), wxSize(21,21), 0, wxDefaultValidator, wxT("edtLockfuse"));

	WxStaticText10 = new wxStaticText(this, ID_WXSTATICTEXT10, wxT("0x"), wxPoint(164,285), wxSize(15,17), 0, wxT("WxStaticText10"));

	chkReadLockfuse = new wxCheckBox(this, ID_CHKREADLOCKFUSE, wxT("Read"), wxPoint(161,264), wxSize(55,17), 0, wxDefaultValidator, wxT("chkReadLockfuse"));

	chkWriteHfuse = new wxCheckBox(this, ID_CHKWRITEHFUSE, wxT("Write"), wxPoint(86,247), wxSize(55,17), 0, wxDefaultValidator, wxT("chkWriteHfuse"));

	edtHfuse = new wxTextCtrl(this, ID_EDTHFUSE, wxT("00"), wxPoint(104,282), wxSize(21,21), 0, wxDefaultValidator, wxT("edtHfuse"));

	WxStaticText9 = new wxStaticText(this, ID_WXSTATICTEXT9, wxT("0x"), wxPoint(89,285), wxSize(15,17), 0, wxT("WxStaticText9"));

	chkReadHfuse = new wxCheckBox(this, ID_CHKREADHFUSE, wxT("Read"), wxPoint(86,263), wxSize(55,17), 0, wxDefaultValidator, wxT("chkReadHfuse"));

	WxStaticBox6 = new wxStaticBox(this, ID_WXSTATICBOX6, wxT("Lock Fuse"), wxPoint(154,231), wxSize(66,79));

	WxStaticBox9 = new wxStaticBox(this, ID_WXSTATICBOX9, wxT("Signature"), wxPoint(402,231), wxSize(74,79));

	WxStaticBox8 = new wxStaticBox(this, ID_WXSTATICBOX8, wxT("Calibration"), wxPoint(304,231), wxSize(90,79));

	WxStaticBox7 = new wxStaticBox(this, ID_WXSTATICBOX7, wxT("Extd. Fuse"), wxPoint(229,231), wxSize(66,79));

	WxStaticBox5 = new wxStaticBox(this, ID_WXSTATICBOX5, wxT("High Fuse"), wxPoint(79,231), wxSize(66,79));

	WxStaticText8 = new wxStaticText(this, ID_WXSTATICTEXT8, wxT("0x"), wxPoint(15,285), wxSize(15,17), 0, wxT("WxStaticText8"));

	edtLfuse = new wxTextCtrl(this, ID_EDTLFUSE, wxT("00"), wxPoint(30,282), wxSize(21,21), 0, wxDefaultValidator, wxT("edtLfuse"));

	chkReadLfuse = new wxCheckBox(this, ID_CHKREADLFUSE, wxT("Read"), wxPoint(12,264), wxSize(55,17), 0, wxDefaultValidator, wxT("chkReadLfuse"));

	chkWriteLfuse = new wxCheckBox(this, ID_CHKWRITELFUSE, wxT("Write"), wxPoint(12,248), wxSize(55,17), 0, wxDefaultValidator, wxT("chkWriteLfuse"));

	WxStaticBox4 = new wxStaticBox(this, ID_WXSTATICBOX4, wxT("Low Fuse"), wxPoint(4,231), wxSize(66,79));

	chkWriteEeprom = new wxCheckBox(this, ID_CHKWRITEEEPROM, wxT("Write"), wxPoint(12,176), wxSize(57,23), 0, wxDefaultValidator, wxT("chkWriteEeprom"));

	WxStaticText7 = new wxStaticText(this, ID_WXSTATICTEXT7, wxT("Format:"), wxPoint(480,181), wxSize(39,17), 0, wxT("WxStaticText7"));

	wxArrayString arrayStringFor_cmbEepromFormat;
	arrayStringFor_cmbEepromFormat.Add(wxT("Autodetect"));
	arrayStringFor_cmbEepromFormat.Add(wxT("Intel Hex"));
	arrayStringFor_cmbEepromFormat.Add(wxT("Motorola"));
	arrayStringFor_cmbEepromFormat.Add(wxT("Raw binary"));
	arrayStringFor_cmbEepromFormat.Add(wxT("Immediate mode"));
	cmbEepromFormat = new wxComboBox(this, ID_WXCOMBOBOX1, wxT(""), wxPoint(480,199), wxSize(102,22), arrayStringFor_cmbEepromFormat, wxCB_READONLY, wxDefaultValidator, wxT("cmbEepromFormat"));
	cmbEepromFormat->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("Courier New")));

	btnOpenEepromFile = new wxButton(this, ID_WXBUTTON2, wxT("..."), wxPoint(445,198), wxSize(20,23), 0, wxDefaultValidator, wxT("btnOpenEepromFile"));

	chkVerifyEeprom = new wxCheckBox(this, ID_WXCHECKBOX3, wxT("Verify"), wxPoint(252,176), wxSize(57,23), 0, wxDefaultValidator, wxT("chkVerifyEeprom"));

	chkReadEeprom = new wxCheckBox(this, ID_WXCHECKBOX2, wxT("Read"), wxPoint(132,176), wxSize(57,23), 0, wxDefaultValidator, wxT("chkReadEeprom"));

	edtEepromFile = new wxTextCtrl(this, ID_WXEDIT2, wxT("eeprom.hex"), wxPoint(12,199), wxSize(426,22), 0, wxDefaultValidator, wxT("edtEepromFile"));
	edtEepromFile->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("Courier New")));

	WxStaticBox3 = new wxStaticBox(this, ID_WXSTATICBOX3, wxT("EEPROM"), wxPoint(4,162), wxSize(584,67));

	btnStatusGiveio = new wxButton(this, ID_BTNSTATUSGIVEIO, wxT("Status"), wxPoint(482,66), wxSize(75,21), 0, wxDefaultValidator, wxT("btnStatusGiveio"));

	btnRemoveGiveio = new wxButton(this, ID_BTNREMOVEGIVEIO, wxT("Remove"), wxPoint(482,42), wxSize(75,21), 0, wxDefaultValidator, wxT("btnRemoveGiveio"));

	btnInstallGiveio = new wxButton(this, ID_BTNINSTALLGIVEIO, wxT("Install"), wxPoint(482,18), wxSize(75,21), 0, wxDefaultValidator, wxT("btnInstallGiveio"));

	grpGiveio = new wxStaticBox(this, ID_GRPGIVEIO, wxT("GiveIO Driver"), wxPoint(474,1), wxSize(90,92));

	WxStaticText6 = new wxStaticText(this, ID_WXSTATICTEXT6, wxT("Format:"), wxPoint(480,113), wxSize(39,17), 0, wxT("WxStaticText6"));

	wxArrayString arrayStringFor_cmbFlashFormat;
	arrayStringFor_cmbFlashFormat.Add(wxT("Autodetect"));
	arrayStringFor_cmbFlashFormat.Add(wxT("Intel Hex"));
	arrayStringFor_cmbFlashFormat.Add(wxT("Motorola"));
	arrayStringFor_cmbFlashFormat.Add(wxT("Raw binary"));
	arrayStringFor_cmbFlashFormat.Add(wxT("Immediate mode"));
	cmbFlashFormat = new wxComboBox(this, ID_CMBFLASHFORMAT, wxT(""), wxPoint(478,131), wxSize(102,22), arrayStringFor_cmbFlashFormat, wxCB_READONLY, wxDefaultValidator, wxT("cmbFlashFormat"));
	cmbFlashFormat->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("Courier New")));

	btnOpenFlashFile = new wxButton(this, ID_BTNOPENFLASHFILE, wxT("..."), wxPoint(445,130), wxSize(20,23), 0, wxDefaultValidator, wxT("btnOpenFlashFile"));

	chkVerifyFlash = new wxCheckBox(this, ID_CHKVERIFYFLASH, wxT("Verify"), wxPoint(252,108), wxSize(57,23), 0, wxDefaultValidator, wxT("chkVerifyFlash"));

	chkReadFlash = new wxCheckBox(this, ID_CHKREADFLASH, wxT("Read"), wxPoint(132,108), wxSize(57,23), 0, wxDefaultValidator, wxT("chkReadFlash"));

	chkWriteFlash = new wxCheckBox(this, ID_CHKWRITEFLASH, wxT("Write"), wxPoint(12,108), wxSize(57,23), 0, wxDefaultValidator, wxT("chkWriteFlash"));

	edtFlashFile = new wxTextCtrl(this, ID_EDTFLASHFILE, wxT("flash.hex"), wxPoint(12,131), wxSize(426,22), 0, wxDefaultValidator, wxT("edtFlashFile"));
	edtFlashFile->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("Courier New")));

	WxStaticBox1 = new wxStaticBox(this, ID_WXSTATICBOX1, wxT("Flash"), wxPoint(4,94), wxSize(584,67));

	wxArrayString arrayStringFor_cmbPort;
	arrayStringFor_cmbPort.Add(wxT("lpt1"));
	arrayStringFor_cmbPort.Add(wxT("lpt2"));
	arrayStringFor_cmbPort.Add(wxT("lpt3"));
	arrayStringFor_cmbPort.Add(wxT("com1"));
	arrayStringFor_cmbPort.Add(wxT("com2"));
	arrayStringFor_cmbPort.Add(wxT("com3"));
	arrayStringFor_cmbPort.Add(wxT("com4"));
	arrayStringFor_cmbPort.Add(wxT("com5"));
	arrayStringFor_cmbPort.Add(wxT("com6"));
	arrayStringFor_cmbPort.Add(wxT("com7"));
	arrayStringFor_cmbPort.Add(wxT("com8"));
	cmbPort = new wxComboBox(this, ID_CMBPORT, wxT(""), wxPoint(253,65), wxSize(91,22), arrayStringFor_cmbPort, 0, wxDefaultValidator, wxT("cmbPort"));
	cmbPort->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("Courier New")));

	wxArrayString arrayStringFor_cmbProgrammer;
	arrayStringFor_cmbProgrammer.Add(wxT("abcmini"));
	arrayStringFor_cmbProgrammer.Add(wxT("alf"));
	arrayStringFor_cmbProgrammer.Add(wxT("avr910"));
	arrayStringFor_cmbProgrammer.Add(wxT("avrisp"));
	arrayStringFor_cmbProgrammer.Add(wxT("bascom"));
	arrayStringFor_cmbProgrammer.Add(wxT("bsd"));
	arrayStringFor_cmbProgrammer.Add(wxT("butterfly"));
	arrayStringFor_cmbProgrammer.Add(wxT("dt006"));
	arrayStringFor_cmbProgrammer.Add(wxT("futurlec"));
	arrayStringFor_cmbProgrammer.Add(wxT("pavr"));
	arrayStringFor_cmbProgrammer.Add(wxT("picoweb"));
	arrayStringFor_cmbProgrammer.Add(wxT("pony-stk200"));
	arrayStringFor_cmbProgrammer.Add(wxT("sp12"));
	arrayStringFor_cmbProgrammer.Add(wxT("stk200"));
	arrayStringFor_cmbProgrammer.Add(wxT("stk500"));
	arrayStringFor_cmbProgrammer.Add(wxT("usbasp"));
	cmbProgrammer = new wxComboBox(this, ID_CMBPROGRAMMER, wxT(""), wxPoint(132,65), wxSize(91,22), arrayStringFor_cmbProgrammer, 0, wxDefaultValidator, wxT("cmbProgrammer"));
	cmbProgrammer->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("Courier New")));

	WxStaticText5 = new wxStaticText(this, ID_WXSTATICTEXT5, wxT("-P Port:"), wxPoint(252,48), wxSize(39,17), 0, wxT("WxStaticText5"));

	WxStaticText4 = new wxStaticText(this, ID_WXSTATICTEXT4, wxT("-c Programmer:"), wxPoint(132,48), wxSize(75,17), 0, wxT("WxStaticText4"));

	WxStaticText3 = new wxStaticText(this, ID_WXSTATICTEXT3, wxT("-p Device:"), wxPoint(12,48), wxSize(53,17), 0, wxT("WxStaticText3"));

	wxArrayString arrayStringFor_cmbDevice;
	arrayStringFor_cmbDevice.Add(wxT("AT90S1200"));
	arrayStringFor_cmbDevice.Add(wxT("AT90S2313"));
	arrayStringFor_cmbDevice.Add(wxT("AT90S2333"));
	arrayStringFor_cmbDevice.Add(wxT("AT90S2343"));
	arrayStringFor_cmbDevice.Add(wxT("AT90S4414"));
	arrayStringFor_cmbDevice.Add(wxT("AT90S4433"));
	arrayStringFor_cmbDevice.Add(wxT("AT90S4434"));
	arrayStringFor_cmbDevice.Add(wxT("AT90S8515"));
	arrayStringFor_cmbDevice.Add(wxT("AT90S8535"));
	arrayStringFor_cmbDevice.Add(wxT("ATmega103"));
	arrayStringFor_cmbDevice.Add(wxT("ATmega128"));
	arrayStringFor_cmbDevice.Add(wxT("ATmega16"));
	arrayStringFor_cmbDevice.Add(wxT("ATmega161"));
	arrayStringFor_cmbDevice.Add(wxT("ATmega162"));
	arrayStringFor_cmbDevice.Add(wxT("ATmega163"));
	arrayStringFor_cmbDevice.Add(wxT("ATmega169"));
	arrayStringFor_cmbDevice.Add(wxT("ATmega32"));
	arrayStringFor_cmbDevice.Add(wxT("ATmega48"));
	arrayStringFor_cmbDevice.Add(wxT("ATmega64"));
	arrayStringFor_cmbDevice.Add(wxT("ATmega8"));
	arrayStringFor_cmbDevice.Add(wxT("ATmega8515"));
	arrayStringFor_cmbDevice.Add(wxT("ATmega8535"));
	arrayStringFor_cmbDevice.Add(wxT("ATmega88"));
	arrayStringFor_cmbDevice.Add(wxT("ATtiny12"));
	arrayStringFor_cmbDevice.Add(wxT("ATtiny13"));
	arrayStringFor_cmbDevice.Add(wxT("ATtiny15"));
	arrayStringFor_cmbDevice.Add(wxT("ATtiny2313"));
	arrayStringFor_cmbDevice.Add(wxT("ATtiny26"));
	cmbDevice = new wxComboBox(this, ID_CMBDEVICE, wxT(""), wxPoint(12,65), wxSize(91,22), arrayStringFor_cmbDevice, 0, wxDefaultValidator, wxT("cmbDevice"));
	cmbDevice->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("Courier New")));

	WxStaticText2 = new wxStaticText(this, ID_WXSTATICTEXT2, wxT("Alt. config file:"), wxPoint(12,27), wxSize(70,17), 0, wxT("WxStaticText2"));

	btnOpenConfFile = new wxButton(this, ID_WXBUTTON1, wxT("..."), wxPoint(444,24), wxSize(20,23), 0, wxDefaultValidator, wxT("btnOpenConfFile"));

	edtConfFile = new wxTextCtrl(this, ID_WXEDIT1, wxT(""), wxPoint(116,25), wxSize(320,22), 0, wxDefaultValidator, wxT("edtConfFile"));
	edtConfFile->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("Courier New")));

	btnOpenAvrdudeFile = new wxButton(this, ID_BTNOPENAVRDUDEFILE, wxT("..."), wxPoint(444,0), wxSize(20,23), 0, wxDefaultValidator, wxT("btnOpenAvrdudeFile"));

	edtAvrdude = new wxTextCtrl(this, ID_EDTAVRDUDE, wxT("avrdude"), wxPoint(116,2), wxSize(320,22), 0, wxDefaultValidator, wxT("edtAvrdude"));
	edtAvrdude->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, FALSE, wxT("Courier New")));

	WxStaticText1 = new wxStaticText(this, ID_WXSTATICTEXT1, wxT("Location of avrdude:"), wxPoint(12,5), wxSize(102,17), 0, wxT("WxStaticText1"));
    ////GUI Items Creation End
 
    cmbPort->Clear();
#ifdef __WXMSW__
	cmbPort->Append(_("lpt1"));
	cmbPort->Append(_("lpt2"));
	cmbPort->Append(_("lpt3"));
	cmbPort->Append(_("com1"));
	cmbPort->Append(_("com2"));
	cmbPort->Append(_("com3"));
	cmbPort->Append(_("com4"));
	cmbPort->Append(_("com5"));
	cmbPort->Append(_("com6"));
	cmbPort->Append(_("com7"));
	cmbPort->Append(_("com8"));
#else
	cmbPort->Append(_("/dev/lp0"));
	cmbPort->Append(_("/dev/lp1"));
	cmbPort->Append(_("/dev/lp2"));
	cmbPort->Append(_("/dev/ttyS0"));
	cmbPort->Append(_("/dev/ttyS1"));
	cmbPort->Append(_("/dev/ttyS2"));
	cmbPort->Append(_("/dev/ttyS3"));
	cmbPort->Append(_("/dev/ttyS4"));
	cmbPort->Append(_("/dev/ttyS5"));
	cmbPort->Append(_("/dev/ttyS6"));
	cmbPort->Append(_("/dev/ttyS7"));
#endif

    cmbDevice->SetSelection(0);
    cmbProgrammer->SetSelection(0);
    cmbPort->SetSelection(0);
    cmbFlashFormat->SetSelection(0);
    cmbEepromFormat->SetSelection(0);
    btnExecute->SetFocus();
  
    m_ControlsCreated = 1;
}

void MainDlg::MainDlgInit(wxInitDialogEvent& event )
{

  LoadSettings();

#ifdef __WXMSW__

#else
    grpGiveio->Show(false);
    btnInstallGiveio->Show(false);
    btnRemoveGiveio->Show(false);
    btnStatusGiveio->Show(false);
#endif
}

void MainDlg::MainDlgClose(wxCloseEvent& event)
{
    SaveSettings();
    
    // --> Don't use Close with a wxDialog,
    // use Destroy instead.
    Destroy();
}

void MainDlg::ChangeSettings(wxCommandEvent& event)
{
    BuildCmdLine();
}

void MainDlg::SelectAvrdude(wxCommandEvent& event)
{
  if (OpenFileDialogAvrdude->ShowModal() == wxID_OK)
  {
    edtAvrdude->SetValue(OpenFileDialogAvrdude->GetPath().c_str());
  }  
}
  
void MainDlg::SelectConfFile(wxCommandEvent& event)
{
  if (OpenFileDialogConfFile->ShowModal() == wxID_OK)
  {
    edtConfFile->SetValue(OpenFileDialogConfFile->GetPath().c_str());
  }  
}
  
void MainDlg::SelectFlash(wxCommandEvent& event)
{
  if (OpenFileDialogFlash->ShowModal() == wxID_OK)
  {
    edtFlashFile->SetValue(OpenFileDialogFlash->GetPath().c_str());
  }  
}
  
void MainDlg::SelectEeprom(wxCommandEvent& event)
{
  if (OpenFileDialogEeprom->ShowModal() == wxID_OK)
  {
    edtEepromFile->SetValue(OpenFileDialogEeprom->GetPath().c_str());
  }  
}

void MainDlg::InstallGiveio(wxCommandEvent& event)
{
  if (wxFile::Exists("install_giveio.bat"))
    ExecWithRedirect("install_giveio.bat");
}

void MainDlg::RemoveGiveio(wxCommandEvent& event)
{
  if (wxFile::Exists("install_giveio.bat"))
    ExecWithRedirect("remove_giveio.bat");
}

void MainDlg::StatusGiveio(wxCommandEvent& event)
{
  ExecWithRedirect("loaddrv status giveio");
}

//ToDo: Switch Power on if SP12-kompatible programmer is available
void MainDlg::LptPowerOn(wxCommandEvent& event)
{
#ifdef __WXMSW__

/*
  HWND hDevice;
  word ret;

  hDevice:= CreateFile("\\.\\giveio",GENERIC_READ,0,nil,
                       OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);

  if (hDevice = INVALID_HANDLE_VALUE)    // did we succeed?
    // possibly call GetLastError() to get a hint what failed
    // and terminate (it is useless to continue if we cant connect to Direct I/O)
//    ShowMessage('GiveIO Driver Not Installed.');
    raise EPortError.Create("GiveIO Driver Not Installed");
*/

  if (chkLptPowerOn->GetValue())
  {
    wxMessageBox("Sorry. This function isn't implemented yet.");

/*
    //power off
    //ToDo: Ermitteln der echten LPT-Adresse im System
    ret:= PortIn($0378);
    //ToDo: echte Verkpfung eintragen
    ret:= ret and $0000;
    PortOut($0378, ret);
*/    
  }
/*
  else
  {
    //power on
    //ToDo: Ermitteln der echten LPT-Adresse im System
    ret:= PortIn($0378);
    //ToDo: echte Verkpfung eintragen
    ret:= ret or $ffff;
    PortOut($0378, ret);
  }
   CloseHandle(hDevice);
*/
#endif
}
 

void MainDlg::Execute(wxCommandEvent& event)
{
  wxSetCursor(*wxHOURGLASS_CURSOR);
  ExecWithRedirect(edtCmdline->GetValue());
  wxSetCursor(*wxSTANDARD_CURSOR);
}

void MainDlg::LoadSettings(void)
{
    bool value;

    wxConfig *cfg = new wxConfig(ConfigFilenameString);  // ->registry

    edtAvrdude->SetValue(cfg->Read("avrdude/path", "avrdude"));
    edtConfFile->SetValue(cfg->Read("options/conf", ""));

    cmbDevice->SetSelection(cfg->Read("options/device", (long)0));

    cmbProgrammer->SetSelection(cfg->Read("options/programmer", (long)0));
    cmbPort->SetSelection(cfg->Read("options/port", (long)0));

    chkWriteFlash->SetValue(cfg->Read("options/write_flash", value));
    chkReadFlash->SetValue(cfg->Read("options/read_flash", value));
    chkVerifyFlash->SetValue(cfg->Read("options/verify_flash", value));
    edtFlashFile->SetValue(cfg->Read("options/flash_file", "flash.hex"));
    cmbFlashFormat->SetSelection(cfg->Read("options/flash_format", (long)0));

    chkWriteEeprom->SetValue(cfg->Read("options/write_eeprom", value));
    chkReadEeprom->SetValue(cfg->Read("options/read_eeprom", value));
    chkVerifyEeprom->SetValue(cfg->Read("options/verify_eeprom", value));
    edtEepromFile->SetValue(cfg->Read("options/eeprom_file", "eeprom.hex"));
    cmbEepromFormat->SetSelection(cfg->Read("options/eeprom_format", (long)0));
    
    chkWriteLfuse->SetValue(cfg->Read("options/write_lfuse", value));
    chkReadLfuse->SetValue(cfg->Read("options/read_lfuse", value));
    edtLfuse->SetValue(cfg->Read("options/lfuse", "00"));

    chkWriteHfuse->SetValue(cfg->Read("options/write_hfuse", value));
    chkReadHfuse->SetValue(cfg->Read("options/read_hfuse", value));
    edtHfuse->SetValue(cfg->Read("options/hfuse", "00"));

    chkWriteEfuse->SetValue(cfg->Read("options/write_efuse", value));
    chkReadEfuse->SetValue(cfg->Read("options/read_efuse", value));
    edtEfuse->SetValue(cfg->Read("options/efuse", "00"));

    chkWriteLockfuse->SetValue(cfg->Read("options/write_lockfuse", value));
    chkReadLockfuse->SetValue(cfg->Read("options/read_lockfuse", value));
    edtLockfuse->SetValue(cfg->Read("options/lockfuse", "00"));

    chkWriteCalibration->SetValue(cfg->Read("options/write_calibration", value));
    chkReadCalibration->SetValue(cfg->Read("options/read_calibration", value));
    edtCalibration->SetValue(cfg->Read("options/calibration", "00000000"));

    chkWriteSignature->SetValue(cfg->Read("options/write_signature", value));
    chkReadSignature->SetValue(cfg->Read("options/read_signature", value));
    edtSignature->SetValue(cfg->Read("options/signature", "000000"));

    chkOptAutoErase->SetValue(cfg->Read("options/disable_auto_erase", value));
    chkOptChipErase->SetValue(cfg->Read("options/perform_chip_erase", value));
    chkOptVerifySignature->SetValue(cfg->Read("options/verify_device_signature", value));
    chkOptDontWrite->SetValue(cfg->Read("options/dont_write", value));
    chkOptDisableOutput->SetValue(cfg->Read("options/disable_process_output", value));
    chkOptVerboseOutput->SetValue(cfg->Read("options/enable_verbose_output", value));
    chkOptDisableVerify->SetValue(cfg->Read("options/disable_verify_check", value));
    chkOptTerminal->SetValue(cfg->Read("options/terminal_mode", value));

    chkExitReset->SetValue(cfg->Read("options/exit_reset", value));
    chkExitNoreset->SetValue(cfg->Read("options/exit_noreset", value));
    chkExitVcc->SetValue(cfg->Read("options/exit_vcc", value));
    chkExitNovcc->SetValue(cfg->Read("options/exit_novcc", value));

    chkCcErase->SetValue(cfg->Read("options/erase_cycle_counter", value));
    chkCcSet->SetValue(cfg->Read("options/set_cycle_counter", value));
    edtCycleCounter->SetValue(cfg->Read("options/cycle_counter", "0"));

    delete cfg;
}    

void MainDlg::SaveSettings(void)
{

//    wxFileConfig *cfg = new wxFileConfig ("", "",
//                                          ConfigFilenameString, "",
//                                          wxCONFIG_USE_LOCAL_FILE | wxCONFIG_USE_RELATIVE_PATH);
    
    wxConfig *cfg = new wxConfig(ConfigFilenameString);  // ->registry

    cfg->Write("avrdude/path", edtAvrdude->GetValue());
    cfg->Write("options/conf", edtConfFile->GetValue());

    cfg->Write("options/device", cmbDevice->GetSelection());
    cfg->Write("options/programmer", cmbProgrammer->GetSelection());
    cfg->Write("options/port", cmbPort->GetSelection());

    cfg->Write("options/write_flash", chkWriteFlash->GetValue());
    cfg->Write("options/read_flash", chkReadFlash->GetValue());
    cfg->Write("options/verify_flash", chkVerifyFlash->GetValue());
    cfg->Write("options/flash_file", edtFlashFile->GetValue());
    cfg->Write("options/flash_format", cmbFlashFormat->GetSelection());

    cfg->Write("options/write_eeprom", chkWriteEeprom->GetValue());
    cfg->Write("options/read_eeprom", chkReadEeprom->GetValue());
    cfg->Write("options/verify_eeprom", chkVerifyEeprom->GetValue());
    cfg->Write("options/eeprom_file", edtEepromFile->GetValue());
    cfg->Write("options/eeprom_format", cmbEepromFormat->GetSelection());

    cfg->Write("options/write_lfuse", chkWriteLfuse->GetValue());
    cfg->Write("options/read_lfuse", chkReadLfuse->GetValue());
    cfg->Write("options/lfuse", edtLfuse->GetValue());

    cfg->Write("options/write_hfuse", chkWriteHfuse->GetValue());
    cfg->Write("options/read_hfuse", chkReadHfuse->GetValue());
    cfg->Write("options/hfuse", edtHfuse->GetValue());

    cfg->Write("options/write_efuse", chkWriteEfuse->GetValue());
    cfg->Write("options/read_efuse", chkReadEfuse->GetValue());
    cfg->Write("options/efuse", edtEfuse->GetValue());

    cfg->Write("options/write_lockfuse", chkWriteLockfuse->GetValue());
    cfg->Write("options/read_lockfuse", chkReadLockfuse->GetValue());
    cfg->Write("options/lockfuse", edtLockfuse->GetValue());

    cfg->Write("options/write_calibration", chkWriteCalibration->GetValue());
    cfg->Write("options/read_calibration", chkReadCalibration->GetValue());
    cfg->Write("options/calibration", edtCalibration->GetValue());

    cfg->Write("options/write_signature", chkWriteSignature->GetValue());
    cfg->Write("options/read_signature", chkReadSignature->GetValue());
    cfg->Write("options/signature", edtSignature->GetValue());

    cfg->Write("options/disable_auto_erase", chkOptAutoErase->GetValue());
    cfg->Write("options/perform_chip_erase", chkOptChipErase->GetValue());
    cfg->Write("options/verify_device_signature", chkOptVerifySignature->GetValue());
    cfg->Write("options/dont_write", chkOptDontWrite->GetValue());
    cfg->Write("options/disable_process_output", chkOptDisableOutput->GetValue());
    cfg->Write("options/enable_verbose_output", chkOptVerboseOutput->GetValue());
    cfg->Write("options/disable_verify_check", chkOptDisableVerify->GetValue());
    cfg->Write("options/terminal_mode", chkOptTerminal->GetValue());

    cfg->Write("options/exit_reset", chkExitReset->GetValue());
    cfg->Write("options/exit_noreset", chkExitNoreset->GetValue());
    cfg->Write("options/exit_vcc", chkExitVcc->GetValue());
    cfg->Write("options/exit_novcc", chkExitNovcc->GetValue());

    cfg->Write("options/erase_cycle_counter", chkCcErase->GetValue());
    cfg->Write("options/set_cycle_counter", chkCcSet->GetValue());
    cfg->Write("options/cycle_counter", edtCycleCounter->GetValue());

    delete cfg;
}
    
void MainDlg::ExecWithRedirect(const wxString& cmd, bool sync)
{
    //sync exec
    if (sync)
    {
        wxArrayString output, errors;
        int code = wxExecute(cmd, output, errors);
//no statusbar :(        
//        wxLogStatus(_T("command '%s' terminated with exit code %d."), cmd.c_str(), code);

        if ( code != -1 )
        {
            ShowOutput(output);
            ShowOutput(errors);
        }
    }

    //async exec
    else
    {
/*
        MyPipedProcess *process = new MyPipedProcess(this, cmd);
        if ( !wxExecute(cmd, wxEXEC_ASYNC, process) )
        {
            wxLogError(_T("Execution of '%s' failed."), cmd.c_str());
            delete process;
        }
        else
        {
            AddAsyncProcess(process);
        }
*/        
    }
}

void MainDlg::ShowOutput(const wxArrayString& output)
{
    size_t count = output.GetCount();
    if ( !count )
        return;

    lbxOutput->Clear();
    for ( size_t n = 0; n < count; n++ )
    {
        lbxOutput->AppendText(output[n]+"\n");//>Append(output[n]);
    }
}

void MainDlg::BuildCmdLine(void)
{
  wxString device, exitmode, format;

  if (m_ControlsCreated != 0)
  {
    edtCmdline->SetValue("\"" + edtAvrdude->GetValue() + "\"");

  //Device
  if (cmbDevice->GetStringSelection() == "AT90S1200")   device = "1200";
  if (cmbDevice->GetStringSelection() == "AT90S2313")   device = "2313";
  if (cmbDevice->GetStringSelection() == "AT90S2333")   device = "2333";
  if (cmbDevice->GetStringSelection() == "AT90S2343")   device = "2343";
  if (cmbDevice->GetStringSelection() == "AT90S4414")   device = "4414";
  if (cmbDevice->GetStringSelection() == "AT90S4433")   device = "4433";
  if (cmbDevice->GetStringSelection() == "AT90S4434")   device = "4434";
  if (cmbDevice->GetStringSelection() == "AT90S8515")   device = "8515";
  if (cmbDevice->GetStringSelection() == "AT90S8535")   device = "8535";
  if (cmbDevice->GetStringSelection() == "ATmega103")   device = "m103";
  if (cmbDevice->GetStringSelection() == "ATmega128")   device = "m128";
  if (cmbDevice->GetStringSelection() == "ATmega16")    device = "m16";
  if (cmbDevice->GetStringSelection() == "ATmega161")   device = "m161";
  if (cmbDevice->GetStringSelection() == "ATmega162")   device = "m162";
  if (cmbDevice->GetStringSelection() == "ATmega163")   device = "m163";
  if (cmbDevice->GetStringSelection() == "ATmega169")   device = "m169";
  if (cmbDevice->GetStringSelection() == "ATmega32")    device = "m32";
  if (cmbDevice->GetStringSelection() == "ATmega48")    device = "m48";
  if (cmbDevice->GetStringSelection() == "ATmega64")    device = "m64";
  if (cmbDevice->GetStringSelection() == "ATmega8")     device = "m8";
  if (cmbDevice->GetStringSelection() == "ATmega8515")  device = "m8515";
  if (cmbDevice->GetStringSelection() == "ATmega8535")  device = "m8535";
  if (cmbDevice->GetStringSelection() == "ATmega88")    device = "m88";
  if (cmbDevice->GetStringSelection() == "ATtiny12")    device = "t12";
  if (cmbDevice->GetStringSelection() == "ATtiny13")    device = "t13";
  if (cmbDevice->GetStringSelection() == "ATtiny15")    device = "t15";
  if (cmbDevice->GetStringSelection() == "ATtiny2313")  device = "t2313";
  if (cmbDevice->GetStringSelection() == "ATtiny26")    device = "t26";

  edtCmdline->AppendText(" -p " + device);

  edtCmdline->AppendText(" -c " + cmbProgrammer->GetStringSelection());

  if (cmbProgrammer->GetStringSelection() == "sp12")
    chkLptPowerOn->Show(true);
  else
    chkLptPowerOn->Show(false);

  if (edtConfFile->GetValue() != "") edtCmdline->AppendText(" -C \"" + edtConfFile->GetValue()+ "\"");

  edtCmdline->AppendText(" -P " + cmbPort->GetStringSelection());

  //Operationmode
  if (cmbFlashFormat->GetStringSelection() == "Autodetect")     format = "a";
  if (cmbFlashFormat->GetStringSelection() == "Intel Hex")      format = "i";
  if (cmbFlashFormat->GetStringSelection() == "Motorola")       format = "s";
  if (cmbFlashFormat->GetStringSelection() == "Raw binary")     format = "r";
  if (cmbFlashFormat->GetStringSelection() == "Immediate mode") format = "m";
//ToDo: Set file between ""
  if (chkWriteFlash->IsChecked())  edtCmdline->AppendText(" -U flash:w:\"" + edtFlashFile->GetValue() + "\":" + format);
  if (chkReadFlash->IsChecked())   edtCmdline->AppendText(" -U flash:r:\"" + edtFlashFile->GetValue() + "\":" + format);
  if (chkVerifyFlash->IsChecked()) edtCmdline->AppendText(" -U flash:v:\"" + edtFlashFile->GetValue() + "\":" + format);

  if (cmbEepromFormat->GetStringSelection() == "Autodetect")     format = "a";
  if (cmbEepromFormat->GetStringSelection() == "Intel Hex")      format = "i";
  if (cmbEepromFormat->GetStringSelection() == "Motorola")       format = "s";
  if (cmbEepromFormat->GetStringSelection() == "Raw binary")     format = "r";
  if (cmbEepromFormat->GetStringSelection() == "Immediate mode") format = "m";
  if (chkWriteEeprom->IsChecked())  edtCmdline->AppendText(" -U eeprom:w:\"" + edtEepromFile->GetValue() + "\":" + format);
  if (chkReadEeprom->IsChecked())   edtCmdline->AppendText(" -U eeprom:r:\"" + edtEepromFile->GetValue() + "\":" + format);
  if (chkVerifyEeprom->IsChecked()) edtCmdline->AppendText(" -U eeprom:v:\"" + edtEepromFile->GetValue() + "\":" + format);

  //Fuses
  if (chkWriteLfuse->IsChecked()) edtCmdline->AppendText(" -U lfuse:w:0x" + edtLfuse->GetValue() + ":m");
  if (chkReadLfuse->IsChecked())  edtCmdline->AppendText(" -U lfuse:r:lfuse.dat:r");
  edtLfuse->Enable(chkWriteLfuse->IsChecked());

  if (chkWriteHfuse->IsChecked()) edtCmdline->AppendText(" -U hfuse:w:0x" + edtHfuse->GetValue() + ":m");
  if (chkReadHfuse->IsChecked())  edtCmdline->AppendText(" -U hfuse:r:hfuse.dat:r");
  edtHfuse->Enable(chkWriteHfuse->IsChecked());

  if (chkWriteLockfuse->IsChecked()) edtCmdline->AppendText(" -U lock:w:0x" + edtLockfuse->GetValue() + ":m");
  if (chkReadLockfuse->IsChecked())  edtCmdline->AppendText(" -U lock:r:lock_fuse.dat:r");
  edtLockfuse->Enable(chkWriteLockfuse->IsChecked());

  if (chkWriteEfuse->IsChecked()) edtCmdline->AppendText(" -U efuse:w:0x" + edtEfuse->GetValue() + ":m");
  if (chkReadEfuse->IsChecked())  edtCmdline->AppendText(" -U efuse:r:efuse.dat:r");
  edtEfuse->Enable(chkWriteEfuse->IsChecked());

  if (chkWriteCalibration->IsChecked()) edtCmdline->AppendText(" -U calibration:w:0x" + edtCalibration->GetValue() + ":m");
  if (chkReadCalibration->IsChecked())  edtCmdline->AppendText(" -U calibration:r:calibration.dat:r");
  edtCalibration->Enable(chkWriteCalibration->IsChecked());

  if (chkWriteSignature->IsChecked()) edtCmdline->AppendText(" -U signature:w:0x" + edtSignature->GetValue() + ":m");
  if (chkReadSignature->IsChecked())  edtCmdline->AppendText(" -U signature:r:signature.dat:r");
  edtSignature->Enable(chkWriteSignature->IsChecked());

 //Options
  if (chkOptAutoErase->IsChecked())  edtCmdline->AppendText(" -D");
  if (chkOptChipErase->IsChecked())  edtCmdline->AppendText(" -e");
  if (chkOptVerifySignature->IsChecked())  edtCmdline->AppendText(" -F");
  if (chkOptDontWrite->IsChecked())  edtCmdline->AppendText(" -n");
  if (chkOptDisableOutput->IsChecked())  edtCmdline->AppendText(" -q");
  if (chkOptVerboseOutput->IsChecked())  edtCmdline->AppendText(" -v");
  if (chkOptDisableVerify->IsChecked())  edtCmdline->AppendText(" -V");
  if (chkOptTerminal->IsChecked()) edtCmdline->AppendText(" -t");

  //Exitmode
  if (chkExitReset->IsChecked())
    exitmode = "reset";
  if (chkExitNoreset->IsChecked())
    if (exitmode != "")
      exitmode = exitmode + ",noreset";
    else
      exitmode = "noreset";
  if (chkExitVcc->IsChecked())
    if (exitmode != "")
      exitmode = exitmode + ",vcc";
    else
      exitmode = "vcc";
  if (chkExitNovcc->IsChecked())
    if (exitmode != "")
      exitmode = exitmode + ",novcc";
    else
      exitmode = "novcc";

  if (exitmode != "") 
    edtCmdline->AppendText(" -E " + exitmode);

  //counter
  if (chkCcErase->IsChecked()) edtCmdline->AppendText(" -y");
  edtCycleCounter->Enable(chkCcSet->IsChecked());
  if (chkCcSet->IsChecked()) edtCmdline->AppendText(" -Y " + edtCycleCounter->GetValue());

  }
}


/*
 * WxbtnAboutClick
 */
void MainDlg::WxbtnAboutClick(wxCommandEvent& event)
{
	// insert your code here
    wxMessageBox("avrdude-gui v0.2.0\n\n" \
                 "A GUI for the command line tool 'avrdude'\n" \
                 "to program the wide range of \n" \
                 "Atmel AVR RISC microcontrollers.\n\n" \
                 "This software is covered by the GPL.\n\n" \
                 "http://avrdude-gui.sourceforge.net/" \
                 , "avrdude-gui");

	event.Skip();
}

